/*********************************************************************
*项目名称:MG82F6B08_001_104-DEMO
*			测试板使用 MG82F6B08_001_104 SOP16_V11 EV Board (TH221A)
*			CpuCLK=8MHz, SysCLK=8MHz
*功能描述：
*			ADC 10bit, P33作为输入端
*			与内部1.4V作比较,推导实际电压
*注意事项:
*
*建立时间:
*修改日志:
*    
*********************************************************************/
#define _MAIN_C

#include <Intrins.h>
#include <Absacc.h>

#include <Stdio.h>  // for printf

#include ".\include\REG_MG82F6B08_001_104.H"
#include ".\include\Type.h"
#include ".\include\API_Macro_MG82F6B08_001_104.H"
#include ".\include\API_Uart_BRGRL_MG82F6B08_001_104.H"


/*************************************************
*定义系统时钟SysClk (MAX.24MHz)
*可选: 
*	8000000,16000000
*	11059200,22118400
*************************************************/
#define MCU_SYSCLK		8000000
/*************************************************/
/*************************************************
*定义CPU时钟 CpuClk (MAX.16MHz)
*	1) CpuCLK=SysCLK
*	2) CpuClk=SysClk/2
*************************************************/
#define MCU_CPUCLK		(MCU_SYSCLK)
//#define MCU_CPUCLK		(MCU_SYSCLK/2)

#define TIMER_1T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) /256) 			
#define TIMER_1T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) %256)

#define TIMER_12T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) /256) 			
#define TIMER_12T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) %256)

#define LED_R		P32
//#define LED_G_0		P33
#define LED_G_1		P46


#define TEST_ADC_DATA_CNT		16
xdata WordTypeDef TestBuf[TEST_ADC_DATA_CNT];
xdata WordTypeDef TestIVRBuf[TEST_ADC_DATA_CNT];
u8 TestBufLen;

#define VCC_REF					(3300L)
#define ADC_VALUE_MAX			(1024L)
#define IVR_ADC_MIN				(403L)		// 1.3v@3.3V 
#define IVR_ADC_MAX				(465L)		// 1.5v@3.3V
#define IVR_ADC_DEFAULT			(434L)		// 1.4v@3.3V

/*************************************************
*函数名称: char putchar (char c)   
*功能描述: 用于printf 的串口输出程序
*输入参数:     char c
*输出参数:     
*************************************************/
char putchar (char c)   
{      
	bit bES;
	bES=ES0;
    ES0=0;        
    S0BUF = c;        
    while(TI0==0);        
    TI0=0;        
    ES0=bES;        
    return 0;
}

/*************************************************
*函数名称:     void DelayXus(u16 xUs)
*功能描述:   	延时程序，单位为us
*输入参数:     u8 Us -> *1us  (1~255)
*输出参数:     
*************************************************/
void DelayXus(u8 xUs)
{
	while(xUs!=0)
	{
#if (MCU_CPUCLK>=11059200)
		_nop_();
#endif
#if (MCU_CPUCLK>=14745600)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=16000000)
		_nop_();
#endif

#if (MCU_CPUCLK>=22118400)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=24000000)
		_nop_();
		_nop_();
#endif		
#if (MCU_CPUCLK>=29491200)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=32000000)
		_nop_();
		_nop_();
#endif

		xUs--;
	}
}

/*************************************************
*函数名称:     void DelayXms(u16 xMs)
*功能描述:     延时程序，单位为ms
*输入参数:     u16 xMs -> *1ms  (1~65535)
*输出参数:     
*************************************************/
void DelayXms(u16 xMs)
{
	while(xMs!=0)
	{
		CLRWDT();
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		xMs--;
		
	}
}

/***********************************************************************************
*函数名称:   void InitUart0_S0BRG(void)
*功能描述:   Uart0初始化 使用S0BRG作为波特率来源
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitUart0_S0BRG(void)
{
	UART0_SetAccess_S0CR1();			// 设置SFR 0xB9地址是访问S0CR1
	UART0_SetMode8bitUARTVar();			// 8位 可变波特率
	UART0_EnReception();				// 使能接收
	UART0_SetBRGFromS0BRG();			// 设置波特率来源为 S0BRG
	UART0_SetS0BRGBaudRateX2();			// 设置2x波特率
	UART0_SetS0BRGSelSYSCLK();			// 设置S0BRG时钟输入为Sysclk
	UART0_SetRxTxP30P31();
	// Sets B.R. value
	UART0_SetS0BRGValue(S0BRG_BRGRL_9600_2X_8000000_1T);

	UART0_EnS0BRG();					// 开启S0BRG时钟
}

/***********************************************************************************
*函数名称:   void InitPort(void)
*功能描述:   IO配置
*输入参数:   
*输出参数:     
*************************************************************************************/
void InitPort(void)
{
	PORT_SetP3QuasiBi(BIT0|BIT1|BIT2); 				// 设置 P30,P31,P32为双向口,用于RXD/TXD,LED
	PORT_SetP4OpenDrainPu(BIT6);					// 设置 P46为开漏带上拉,用于LED
	PORT_P33_EnAnalogOnly();  						// 设置 P33仅模拟输入，做ADC输入通道
}

/***********************************************************************************
*函数名称:   void InitTimer0(void)
*功能描述:Timer0初始化设置	
*输入参数:   
*输出参数:     
*************************************************************************************/
void InitTimer0(void)
{
	TM_SetT0Mode_1_16BIT_TIMER();			// 设置T0模式为16位模式
	TM_SetT0Clock_SYSCLKDiv12();			// 设置T0时钟源为 SYSCLK/12
	TM_SetT0Gate_Disable();

	TM_SetT0LowByte(0);						// 设置T0低8位
	TM_SetT0HighByte(0);					// 设置T0高8位

	TM_DisableT0();							// 禁止T0
}

/***********************************************************************************
*函数名称:   void InitADC(void)
*功能描述:   ADC初始化
*输入参数:   
*输出参数:     
*************************************************************************************/
void InitADC(void)
{
	ADC_Enable();						// 使能ADC
	ADC_SetClock_SYSCLKDiv2();			// ADC转换时钟为 SYSCLK/2       转换率= 8M/2/24=83.3k
	ADC_SetMode_SetADCS();				// ADC启动模式, 置ADCS
	ADC_SetRightJustified();			// ADC转换数据右对齐
	ADC_SetADCData_10Bit();				// ADC 10bit

	IVREF_Enable();						// 使能内部2.4V
}

/***********************************************************************************
*函数名称:   void InitClock(void)
*功能描述:   时钟初始化	
*输入参数:   
*输出参数:     
*************************************************************************************/
void InitClock(void)
{
#if (MCU_SYSCLK==8000000)
	// Default: IHRCO=16MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK/2
#endif

#if (MCU_SYSCLK==11059200)
	// IHRCO=22.12MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK/2
	CLK_SelIHRCO_22118400Hz();
#endif
	
#if (MCU_SYSCLK==16000000)
	// IHRCO=16MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK
	CLK_SetCKCON3(WDTCS_ILRCO|FWKP_NORMAL_120uS|MCKDO_MCK_DIV_1);
#endif

#if (MCU_SYSCLK==22118400)
	// IHRCO=22.12MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK
	CLK_SelIHRCO_22118400Hz();
	CLK_SetCKCON3(WDTCS_ILRCO|FWKP_NORMAL_120uS|MCKDO_MCK_DIV_1);
#endif
	

#if (MCU_CPUCLK==MCU_SYSCLK)
	CLK_SetCpuclk_Sysclk();
#else
	CLK_SetCpuclk_SysclkDiv2();
#endif

	// P45 输出 MCK/4
	//CLK_P45OC_MCKDiv4();
}


/***********************************************************************************
*函数名称:   void InitSystem(void)
*功能描述:   系统初始化
*输入参数:   
*输出参数:     
*************************************************************************************/
void InitSystem(void)
{
	InitPort();
	InitClock();
	InitUart0_S0BRG();
	InitADC();
	InitTimer0();
}

/***********************************************************************************
*函数名称:   u16 GetAdcData()
*功能描述:	读取当前通道的ADC 
*输入参数:   
*输出参数:   u16 :ADC Value
*************************************************************************************/
u16 GetAdcValue()
{
	WordTypeDef wAdcValue;
	ADCON0 = ADCON0|ADCS;							// 置位ADCS,启动ADC
    while((ADCON0&ADCI)==0);           				// 等待ADC转换完成
    wAdcValue.B.BHigh=ADCDH;
    wAdcValue.B.BLow=ADCDL;
 	ADCON0 = ADCON0&(~ADCI);		           		// 清标志位
	return wAdcValue.W&0x03FF;
}

/***********************************************************************************
*函数名称:   unsigned int GetIVRef()
*功能描述:   读取内部IVRef的校准值
*输入参数:   
*返回参数:   unsigned int :IVRef 在3.3V下的ADC值
*************************************************************************************/
unsigned int GetIVRef()
{
unsigned char IVR_CodeHigh,IVR_CodeLow;
	while((ISPCR&PBSY)!=0);
	
	ISPCR = 0x80;
	IFMT = 0x06;
	IFADRH = 0x00;
	IFADRL = 0x4C;
	
	SCMD = 0x46;
	SCMD = 0xB9;
	IVR_CodeHigh= IFD;

	IFADRL ++;
	SCMD = 0x46;
	SCMD = 0xB9;
	IVR_CodeLow= IFD;

	ISPCR = 0x00;
	
	return (IVR_CodeHigh*256+IVR_CodeLow);
}

void main()
{
	u8 i;
	DWordTypeDef dwTemp,dwIVR;
	WordTypeDef wVinValue,wIVRefValue;
	WordTypeDef wIVRAdjAdc;

	u16 wAdcMIN,wAdcMAX,wAdcAVG;
	WordTypeDef wAdcTime;
	
    InitSystem();
	
	LED_G_1=0;LED_R=0;
	DelayXms(1000);
	LED_G_1=1;LED_R=1;
	
	printf("\nHello...");

	wIVRAdjAdc.W=GetIVRef(); 			

	// 串口输出
	printf("\nIVR ADC@3.3V:%d",wIVRAdjAdc.W);
	// 检测IVRef校准值是否在范围内(1.3~1.5)
	if((wIVRAdjAdc.W <IVR_ADC_MIN)||(wIVRAdjAdc.W>=IVR_ADC_MAX))
	{ // 存储的IVRef值右问题,设为默认值 1.4V@3.3V
		// 串口输出
		wIVRAdjAdc.W=IVR_ADC_DEFAULT;
		printf(" Err..Set Default:%d",wIVRAdjAdc.W);
	}
	// 计算IVR的电压值
	dwTemp.DW=wIVRAdjAdc.W;
	wIVRefValue.W=dwTemp.DW*VCC_REF/ADC_VALUE_MAX;
	printf(", VRef Voltage:%dmV",wIVRefValue.W);


	TestBufLen=0;

	TH0=0;
	TL0=0;
	TM_EnableT0();
    while(1)
    {
    	// 读IO的ADC值
    	ADC_SetChannel_AIN5_P33();
    	DelayXus(10);
    	TestBuf[TestBufLen].W=GetAdcValue();

    	// 读IVR的ADC值
    	ADC_SetChannel_IVR14();
    	DelayXus(10);
    	TestIVRBuf[TestBufLen].W=GetAdcValue();
    	
		LED_R = !LED_R;
		
		TestBufLen++;
		if(TestBufLen>=TEST_ADC_DATA_CNT)
		{
			TM_DisableT0();
			wAdcTime.B.BHigh=TH0;
			wAdcTime.B.BLow=TL0;

			dwIVR.DW=0;
			dwTemp.DW=0;
			wAdcMIN=0xFFFF;
			wAdcMAX=0x0000;
			
			for(i=0;i<(TEST_ADC_DATA_CNT);i++)
			{
				dwIVR.DW=dwIVR.DW+TestIVRBuf[i].W;
				dwTemp.DW=dwTemp.DW+TestBuf[i].W;
				if(wAdcMIN>=TestBuf[i].W)
				{
					wAdcMIN=TestBuf[i].W;
				}
				if(wAdcMAX<TestBuf[i].W)
				{
					wAdcMAX=TestBuf[i].W;
				}
				
			}
			wAdcAVG=dwTemp.DW/TEST_ADC_DATA_CNT;		
			printf("\nADC ");
			printf("Sample cnt:%bd,",i);
			printf("Total time:%d,",wAdcTime.W);
			printf("MIN:%04X,",wAdcMIN);
			printf("MAX:%04X,",wAdcMAX);
			printf("AVG:%04X,",wAdcAVG);

			
			// 计算AIN0的输入电压值
			dwIVR.DW=dwIVR.DW/TEST_ADC_DATA_CNT;
			dwTemp.DW=wIVRAdjAdc.W;
			wVinValue.W=(dwTemp.DW*wAdcAVG*VCC_REF)/(dwIVR.DW*ADC_VALUE_MAX);
			
			// 串口输出
			printf("IO Voltage:%dmV",wVinValue.W);
			DelayXms(1000);
			TestBufLen=0;

			TH0=0;
			TL0=0;
			TM_EnableT0();
		}
    }
}



